/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("net.jazz.ajax.core.internal.util");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

var checkNotNull 	= net.jazz.ajax.toolbox.lang.checkNotNull;

/**
 * Safely calls the specified function (which presumably contains calls to component-contributed
 * code in its body) in a way that will not disrupt the workbench if an exception occurs.
 * 
 * @param {Function} fn
 */
function callContributedCode(fn) {
	//dojo.lang.assertType(fn, Function);
	
	try {
		return fn();
	} catch (e) {
		displayExceptionInfo(e);
		// Rethrow exception if we're not in IE so that it shows up in the
		// console (IE becomes unusable if an exception is thrown and not
		// caught).
		if (!dojo.isIE) {
			throw e;
		}
	}
}

net.jazz.ajax.core.internal.util.callContributedCode = callContributedCode;

function displayExceptionInfo(e) {
	var msg = e.name + ": " + e.message;
	if (djConfig.isDebug && !dojo.isIE) {
		msg += "\nFile: " + e.fileName + " (Line: " + e.lineNumber + ")\n\n" +
			"Stack: " + "\n" + e.stack;
	}
	alert(msg);
}

function removeChildren(node) {
	while(node.firstChild) {
		node.removeChild(node.firstChild);
	}
}

net.jazz.ajax.core.internal.util.removeChildren = removeChildren;

//
// Internal events for dojo.publish
//

dojo.setObject("net.jazz.ajax.internal.events", {
	hideMessageArea: "net.jazz.ajax.internal.hideMessage",
	orderPages: "net.jazz.ajax.internal.orderPages",
	showMessage: "net.jazz.ajax.internal.showMessage",
	viewErrorPage: "net.jazz.ajax.internal.viewErrorPage",
	viewPage: "net.jazz.ajax.internal.events"
});

})();